.486
.model flat, stdcall
option casemap: none

; API functions
; ------------------------------------------------------------------------------
include    include\windows.inc
include    include\user32.inc
include    include\kernel32.inc
include    include\comctl32.inc
include    include\comdlg32.inc
include    include\masm32.inc


includelib    lib\user32.lib
includelib    lib\kernel32.lib
includelib    lib\comctl32.lib
includelib    lib\comdlg32.lib
includelib    lib\masm32.lib
; ------------------------------------------------------------------------------

; Prototype 
; ------------------------------------------------------------------------------
DialogProc PROTO : HWND, : UINT, : WPARAM, : LPARAM

.const

; Resource ids
; ------------------------------------------------------------------------------
IDD_DLG1  	  equ 101
IDC_EXIT      equ 102
IDC_TEXT      equ 103
IDC_EDT1      equ 104
IDI_ICON      equ 200

; Required data

.data
szFile 		    db "Text.txt",0
szTitle         db "EditBox Example-Using '%S'", 0
szError		    db "Please type some text",0
szErrortitle    db "Error",0

szString    db 'You wrote %s',0Dh,0Ah
            db 'Writing %s is nice',0Dh,0Ah
            db 'But it is nicer that we can see %s',0Dh,0Ah,0
;szText_length			equ $ -szString 

szReplace      BYTE    "%s", 0

buffer          db 100 dup(0);this buffer is used to "hold" what we enter in the text box!
FinalszString	db 100 dup(0); This buffer holds buffer + szString #
szText_length	equ $ -FinalszString 
.data?
hInstance HINSTANCE ?
hIcon     HICON     ?
hEdit1			 dd ?
hFile        HANDLE ? ;For writing text
SizeReadWrite DWORD ? ;For writing text
szPrint	db	(szText_length -1) dup (?)
.code

start:

INVOKE InitCommonControls

INVOKE GetModuleHandle, NULL
mov hInstance, eax

INVOKE LoadIcon, eax, IDI_ICON 
mov hIcon, eax
; ---------------------------------------------
;   Call the dialog box stored in resource file
; ---------------------------------------------
INVOKE DialogBoxParam, hInstance, IDD_DLG1 , NULL, ADDR DialogProc, 0
INVOKE ExitProcess, 0


; Dialog procedure
; ------------------------------------------------------------------------------
DialogProc proc hWnd: HWND, uMsg: UINT, wParam: WPARAM, lParam: LPARAM



 .IF uMsg == WM_INITDIALOG
 
  INVOKE SetWindowText, hWnd, addr szTitle 
  INVOKE SendMessage, hWnd, WM_SETICON,ICON_SMALL, hIcon
  	; initialising our editbox
	INVOKE GetDlgItem,hWnd,104	;Windows API result gets stored in eax
		mov hEdit1,eax				;assembler OPCODE stored flag flag from eax moved to hEdit1
	INVOKE SetFocus,hEdit1			;Windows API
  
    .ELSEIF uMsg == WM_COMMAND
    
      .ELSEIF uMsg == WM_CLOSE
    INVOKE EndDialog, hWnd, 0
 .ENDIF

      .IF wParam == IDC_TEXT
  ;first we check if the user has inserted any text
			;if so we copy it to the second textbox
			invoke GetWindowTextLength,hEdit1		;Win API result gets stored in the eax register
			cmp eax,0							;Assembler OPCODE to compare 
			je @F								;Jump if equal to 0 to @@:
				
				;ok here we get only if user has typed some text
			invoke SendMessage,hEdit1,WM_GETTEXT,sizeof buffer,addr buffer  ;here is where we use our local variable ( we call the text we entered)

			invoke  szRep, offset szString, offset FinalszString , offset szReplace, offset buffer

; Create a new file, overwrite any existing file.

invoke CreateFile,addr szFile ,\ 
GENERIC_READ or GENERIC_WRITE ,\
FILE_SHARE_READ or FILE_SHARE_WRITE,\
NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_ARCHIVE,\ ; "CREATE_ALWAYS" will over write exixting file -> "CREATE_NEW" will NOT over write exixting file!
NULL

      .if eax!=INVALID_HANDLE_VALUE		;if file exists ... then                           
      mov hFile,eax
 ; Write our string the the file
 	invoke szLen, offset FinalszString
invoke WriteFile,hFile,addr FinalszString ,eax ,offset SizeReadWrite ,0

; Close handle to file
invoke CloseHandle,hFile
; Sound the success beep sound!
invoke MessageBeep,MB_OK 

	.endif

				jmp Exit						;Assembler OPCDOE jmp means jump now to (Exit)
			@@:								;here is where we came from je @F (User didnt enter any text) also @F means jump forward @B would be jump back :)
			invoke MessageBox,hWnd,offset szError,offset szErrortitle ,MB_ICONINFORMATION
			Exit:			;We exit the Messageloop here
			.ENDIF
		
  
  .IF wParam == IDC_EXIT 
      INVOKE SendMessage, hWnd, WM_CLOSE, 0, 0

    .ENDIF

    xor eax,eax
  ret
DialogProc endp

end start